--
-- Anbauhaecksler
-- This is the specialization for Anbauhaecksler
--
-- M@D Author  Headshot XXL
-- M@D date  24.05.2009
--
-- > Copyright (C) Headshot XXL - www.planet-ls.de < --

Anbauhaecksler = {};

function Anbauhaecksler.prerequisitesPresent(specializations)
	return true;
end;

function Anbauhaecksler:load(xmlFile)

	local count = getXMLInt(xmlFile, "vehicle.rotationParts#count");
    self.rotationParts = {}
	local rotationPart = self.rotationParts;
    for i=1, count do
		local varName = string.format("rotationPart" .. "%d", i);
		rotationPart[varName] = {};
        local rotationPartname = string.format("vehicle.rotationParts.rotationPart" .. "%d", i);
	    rotationPart[varName].index = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, rotationPartname .. "#index"));
	    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#minRot"));
	    rotationPart[varName].minRot = {};
	    rotationPart[varName].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
	    rotationPart[varName].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
	    rotationPart[varName].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, rotationPartname .. "#maxRot"));
		rotationPart[varName].maxRot = {};
	    rotationPart[varName].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
	    rotationPart[varName].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
	    rotationPart[varName].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

		rotationPart[varName].rotTime = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#rotTime"), 2)*1000;	
		rotationPart[varName].touchRotLimit = Utils.getNoNil(getXMLInt(xmlFile, rotationPartname .. "#touchRotLimit"), 1)/1000;	
    end;

	self.pipeParticleSystems = {};
    --self.pipe = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipe#index"));
	--self.pipeklappe = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipeklappe#index"));
	self.rotationPart3 = self.rotationParts.rotationPart3.index;
	Utils.loadParticleSystem(xmlFile, self.pipeParticleSystems, "vehicle.pipeParticleSystem", self.rotationPart3, false, "$data/vehicles/particleSystems/wheatParticleSystem.i3d", self.baseDirectory);
                 
	--self.pipeentladepoint1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipeentladepoint1#index"));
	self.pipeentladepoint2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.pipeentladepoint2#index"));


	self.fruitTypes = {};
    self.fruitTypes[FruitUtil.FRUITTYPE_UNKNOWN] = true;
    local fruitTypes = getXMLString(xmlFile, "vehicle.fruitTypes#fruitTypes");
    if fruitTypes ~= nil then
        local types = Utils.splitString(" ", fruitTypes);
        for k,v in pairs(types) do
            local desc = FruitUtil.fruitTypes[v];
            if desc ~= nil then
                self.fruitTypes[desc.index] = true;
            end;
        end;
    end;
	
	self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;

    self.currentFruitType = FruitUtil.FRUITTYPE_UNKNOWN;

    self.isTurnedOn = false;
	
	self.lastArea = 0;
	
	self.combineTime2 = 0;
	self.combineTime3 = 0;
end;

function Anbauhaecksler:delete()
end;

function Anbauhaecksler:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Anbauhaecksler:keyEvent(unicode, sym, modifier, isDown)
end;

function Anbauhaecksler:update(dt)

    if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
            self.isTurnedOn = not self.isTurnedOn;
        end;
    end;
	
	self.lastArea = 0;
	self.deltaLevel = 0;
	local fruitType = FruitUtil.FRUITTYPE_UNKNOWN;
	
    if self:getIsActive() then
	
        if self.isTurnedOn then		
			for fruitType,v in pairs(self.fruitTypes) do
				for k,area in pairs(self.cuttingAreas) do
					local x,y,z = getWorldTranslation(area.start);
					local x1,y1,z1 = getWorldTranslation(area.width);
					local x2,y2,z2 = getWorldTranslation(area.height);
					local area = Utils.getFruitArea(fruitType, x, z, x1, z1, x2, z2);
					if area > 0 then
						self.currentFruitType = fruitType;
					end;
				end;
			end;			
			for k,area in pairs(self.cuttingAreas) do
				local x,y,z = getWorldTranslation(area.start);
				local x1,y1,z1 = getWorldTranslation(area.width);
				local x2,y2,z2 = getWorldTranslation(area.height);
				Utils.updateFruitCutShortArea(self.currentFruitType, x, z, x1, z1, x2, z2, 1);
				local area = Utils.cutFruitArea(self.currentFruitType, x, z, x1, z1, x2, z2);
				if area > 0 then
					local spray = Utils.getDensity(g_currentMission.terrainDetailId, g_currentMission.sprayChannel, x, z, x1, z1, x2, z2);
					local multi = 1;
					if spray > 0 then
						multi = 2;
					end;
					self.lastArea = self.lastArea + area*multi;
					
					self.combineTime3 = 50;	
					self.combineTime2Start = true;
					local pixelToQm = 2048 / 4096 * 2048 / 4096  / g_currentMission.maxFruitValue; -- 4096px are mapped to 2048m
					local literPerQm = 1;
					if (self.currentFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN) then
						literPerQm = FruitUtil.fruitIndexToDesc[self.currentFruitType].literPerQm * (1 + 0.5 * (3 - g_currentMission.missionStats.difficulty));
					end;
					
					local qm = self.lastArea*pixelToQm;
					self.deltaLevel = qm*literPerQm
				end;					
			end;
			    local nearestDistance = 3.0;
				local px, py, pz = getWorldTranslation(self.pipeentladepoint2);
				for i=1, table.getn(g_currentMission.attachables) do
					local vx, vy, vz = getWorldTranslation(g_currentMission.attachables[i].rootNode);
					local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);

					if distance < nearestDistance then
						local attachable = g_currentMission.attachables[i];
						for fruitType,v in pairs(attachable.fillTypes) do
							if fruitType == FruitUtil.FRUITTYPE_GRASS and attachable.allowFillFromAir and attachable.rootNode ~= self.rootNode and attachable.setFillLevel ~= nil then
								attachable:setFillLevel(attachable.fillLevel + self.deltaLevel, FruitUtil.FRUITTYPE_GRASS);
							end;
						end;
					end;
				end;			
		end;
		
		
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERYPIPERIGHT) then
			local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;		
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERYPIPELEFT) then
			local rotationPart = self.rotationParts.rotationPart1;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
	    end;  
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERXPIPEDOWN) then
			local rotationPart = self.rotationParts.rotationPart2;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERXPIPEUP) then
			local rotationPart = self.rotationParts.rotationPart2;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));
	    end;
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERKLAPPEDOWN) then
			local rotationPart = self.rotationParts.rotationPart3;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, true);
			setRotation(rotationPart.index, unpack(newRot));
	    end;
		if InputBinding.isPressed(InputBinding.ANBAUHAECKSLERKLAPPEUP) then
			local rotationPart = self.rotationParts.rotationPart3;
			local rot = {getRotation(rotationPart.index)};
			local newRot = Utils.getMovedLimitedValues(rot, rotationPart.maxRot, rotationPart.minRot, 3, rotationPart.rotTime, dt, false);
			setRotation(rotationPart.index, unpack(newRot));		
		end;
		
		local rotationPart = self.rotationParts.rotationPart3;
		local xr,yr,zr = getRotation(rotationPart.index);
		local xt,yt,zt = getTranslation(self.pipeentladepoint2);		
		local zl = 7 * math.cos(xr)
		setTranslation(self.pipeentladepoint2, xt, yt, -zl);
	end;

	if self.lastArea == 0 then
		self.combineTime3 = self.combineTime3 - 1;		
	end;	
	if self.combineTime2Start then
		self.combineTime2 = self.combineTime2 + 1;
	end;
	if self.combineTime2 > 50 then
		self.pipeParticleActivated = true;
		self.combineTime2 = 51;
	end;
	if self.combineTime3 < 1 then
		self.pipeParticleActivated = false;
		self.combineTime2 = 0;
	end;	
	Utils.setEmittingState(self.pipeParticleSystems, self.pipeParticleActivated);
	
	--[[
	local pipeRotationSpeed = 0.0006;
	local pipeMinRotY = -360*3.1415/180.0;
	local pipeMaxRotY = 360*3.1415/180.0;
	local pipeMinRotX = -40*3.1415/180.0;
	local pipeMaxRotX = 0*3.1415/180.0;
	local pipeXRotationSpeed = 0.0006;
	local pipeklappeMaxRotX = 0*3.1415/180.0;
	local pipeklappeMinRotX = -70*3.1415/180.0;
	local pipeentladepointMin = 40;
	local pipeentladepointMax = -40;
	local pipeentladepointtransSpeed = 0.004;
	if self.pipe ~= nil then
		local x,y,z = getRotation(self.pipe);
		--if self.pipeOpening then
		if Input.isKeyPressed(self.keys.YPIPELEFT) then --Input[self.YPIPELEFT] then 
			y = y-dt*pipeRotationSpeed;
		elseif Input.isKeyPressed(self.keys.YPIPERIGHT) then
			y = y+dt*pipeRotationSpeed;
		end;
		if y < pipeMinRotY then
			y = pipeMinRotY;
		end;
		if y > pipeMaxRotY then
			y = pipeMaxRotY;
		end;
		
		if Input.isKeyPressed(self.keys.XPIPEUP) then		
			x = x+dt*pipeXRotationSpeed;                
		elseif Input.isKeyPressed(self.keys.XPIPEDOWN) then
			x = x-dt*pipeXRotationSpeed;                
		end;
		if x > pipeMaxRotX then
			x = pipeMaxRotX;
		end;
		if x < pipeMinRotX then
			x = pipeMinRotX;
		end;
		
		setRotation(self.pipe, x, y, z);
		--self.pipeOpen = (math.abs(pipeMinRotY-y) < 0.01);
	end;
	if self.pipeklappe ~= nil then
		local x,y,z = getRotation(self.pipeklappe);
		local px,py,pz = getTranslation(self.pipeentladepoint2);
		
		if Input.isKeyPressed(self.keys.KLAPPEUP) then		
			x = x+dt*pipeXRotationSpeed;
			pz = pz-dt*pipeentladepointtransSpeed;         				
		elseif Input.isKeyPressed(self.keys.KLAPPEDOWN) then
			x = x-dt*pipeXRotationSpeed; 
			pz = pz+dt*pipeentladepointtransSpeed; 				
		end;
		if x > pipeklappeMaxRotX then
			x = pipeklappeMaxRotX;
		end;
		if x < pipeklappeMinRotX then
			x = pipeklappeMinRotX;
		end;
		if pz < pipeentladepointMax then
			pz = pipeentladepointMax;
		end;
		if pz > pipeentladepointMin then
			pz = pipeentladepointMin;
		end;
		
		setRotation(self.pipeklappe, x, y, z);
		setTranslation(self.pipeentladepoint2, px, py, pz);
		--self.pipeOpen = (math.abs(pipeMinRotY-y) < 0.01);
	end;]]

end;

function Anbauhaecksler:draw()

    if self.isTurnedOn then
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_off_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
    else
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_on_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
    end;
	
	if g_currentMission.attachableInMountRange ~= nil then
		g_currentMission.hudAttachmentOverlay:render();
	end;

end;

function Anbauhaecksler:onDetach()
    if self.deactivateOnDetach then
        Anbauhaecksler.onDeactivate(self);
    end;
end;

function Anbauhaecksler:onLeave()
    if self.deactivateOnLeave then
        Anbauhaecksler.onDeactivate(self);
    end;
end;

function Anbauhaecksler:onDeactivate()
    self.isTurnedOn = false;
end;

--function Anbauhaecksler:validateAttacherJoint(implement, jointDesc, dt)
	--return true;
--end;
